/******************************************************************************
 *  Name:    Reference Solution
 *  NetID:   ref
 *  Precept: P00
 *
 *  Description:  Reads the integers m and n from standard input;
 *                reads n integers between 1 and m from standard input;
 *                prints the entropy of those n integers to standard output.
 *
 ******************************************************************************/

public class ShannonEntropy {

    // returns the base-2 logarithm of x
    private static double log2(double x) {
        return Math.log(x) / Math.log(2);
    }

    public static void main(String[] args) {

        // sequence of n integers are between 1 and m
        int m = StdIn.readInt();

        // number of integers
        int n = StdIn.readInt();

        // compute frequencies
        // freq[i] = # times integer i appears
        int[] freq = new int[m+1];
        for (int j = 0; j < n; j++) {
            int value = StdIn.readInt();
            freq[value]++;
        }

        // compute Shannon entropy
        double entropy = 0.0;
        for (int i = 1; i <= m; i++) {
            double p = 1.0 * freq[i] / n;
            if (freq[i] > 0) entropy -= p * log2(p);
        }

        // print results
        StdOut.println(entropy);
    }
}
